
#include <stdio.h>
#include <fcntl.h>
#include <sys/times.h>
#include <unistd.h>
#include <string.h>
#include <linux/ioctl.h>

#define MAGIC_NUM 'S'
#define IOCTL_3544_MODE_SET _IOW(MAGIC_NUM, 5, unsigned short)

void usage_display( void );

int main( int argc, char ** argv )
{
    int dev_file;
    char *dev_str;
    int temp;
    unsigned short mode_num = 422;


    if( argc < 3 ){
       usage_display();
       return 1;
    }

    dev_str = strstr( argv[1], "/dev/ttyL" );

    if( dev_str == NULL ){
       usage_display();
       return 1;
    }

    if( !strcmp( argv[2], "422" ) ){ // RS-422 match
       mode_num = 422;
    }else if( !strcmp( argv[2], "485" ) ){ // RS-485 match
       mode_num = 485;
    }else{
       printf(" mode of serial port error! 422 or 485 \n\n" );
       usage_display();
       return 1;
    }

    dev_file = open( dev_str, O_RDWR );
    if( ioctl(dev_file, IOCTL_3544_MODE_SET, &mode_num )!= 0 )// some error
       printf(" error : The device is used by aother task\n" );


}

void usage_display( void )
{
    printf(" Usage: mode_set device_node Mode \n");
    printf("    ex. mode_set /dev/ttyL2 422 --- set 3rd port with RS-422 mode \n");
    printf("    ex. mode_set /dev/ttyL1 485 --- set 2nd port with RS-485 mode \n");
}
